<template>
  <q-layout view="lHh Lpr lFf">
    <q-header class="bg-dark" bordered>
      <q-toolbar class="constrain">
        <q-btn
          flat
          to="/camera"
          class="large-screen-only q-mr-sm"
          icon="eva-camera-outline"
          size="18px"
          round
          dense
        />
        <q-separator vertical class="large-screen-only" spaced />
        <q-toolbar-title class="text-grand-hotel text-bold">
          HotStoc
        </q-toolbar-title>
        <q-btn
          flat
          to="/"
          class="large-screen-only"
          icon="eva-home-outline"
          size="18px"
          round
          dense
        />
      </q-toolbar>
    </q-header>

    <q-footer class="bg-dark" bordered>
      <transition
        appear
        enter-active-class="animated fadeIn"
        leave-active-class="animated fadeOut"
      >
        <div v-if="showAppInstallBanner" class="bg-primary">
          <div class="constrain">
            <q-banner class="bg-primary text-white" inline-actions dense>
              Install HotStock?

              <template v-slot:action>
                <q-btn @click="installApp" flat label="YES" />
                <q-btn
                  @click="showAppInstallBanner = false"
                  flat
                  label="LATER"
                />
                <q-btn @click="neverShowAppInstallBanner" flat label="NEVER" />
              </template>
            </q-banner>
          </div>
        </div>
      </transition>
      <q-tabs
        class="text-white small-screen-only"
        active-color="primary"
        indicator-color="transparent"
      >
        <q-route-tab icon="eva-home-outline" to="/" />
        <q-route-tab icon="eva-camera-outline" to="/camera" />
      </q-tabs>
    </q-footer>

    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script>
let deferredPrompt;

export default {
  name: "MainLayout",
  data() {
    return {
      showAppInstallBanner: false
    };
  },
  methods: {
    installApp() {
      // Hide the app provided install promotion
      this.showAppInstallBanner = false;
      // Show the install prompt
      deferredPrompt.prompt();
      // Wait for the user to respond to the prompt
      deferredPrompt.userChoice.then(choiceResult => {
        if (choiceResult.outcome === "accepted") {
          console.log("User accepted the install prompt");
          this.neverShowAppInstallBanner();
        } else {
          console.log("User dismissed the install prompt");
        }
      });
    },
    neverShowAppInstallBanner() {
      this.showAppInstallBanner = false;
      this.$q.localStorage.set("neverShowAppInstallBanne", true);
    }
  },
  mounted() {
    let neverShowAppInstallBanner = this.$q.localStorage.getItem(
      "neverShowAppInstallBanner"
    );

    if (!neverShowAppInstallBanner) {
      window.addEventListener("beforeinstallprompt", e => {
        // Prevent the mini-infobar from appearing on mobile
        e.preventDefault();
        // Stash the event so it can be triggered later.
        deferredPrompt = e;
        // Update UI notify the user they can install the PWA
        setTimeout(() => {
          this.showAppInstallBanner = true;
        }, 2000);
      });
    }
  }
};
</script>

<style lang="sass">
.q-toolbar
  @media (min-width: $breakpoint-xs-max)
    height: 77px
.q-toolbar__title
  font-size: 30px
  @media (max-width: $breakpoint-xs-max)
   text-align: center
.q-footer
  .q-tab__icon
    font-size: 30px
</style>
